*
* NAME: MAILER.PRG
*
* TYPE: 32-bit Visual FoxPro
*
* DATE: March 27, 2002
*
* PURPOSE: This program connects to the SMTP server specified by 'SmtpServer'
*   and emails message 'Message' to 'SmtpTo' with subject 'Subject' and
*   attachment 'Attachment'.
*
* NOTE: It is highly recommended that INCLUDE statements be replaced by their contents.
*
#INCLUDE KEYCODE.FOX
***  SEE32CON.FOX
***
***  DEFINE's for Visual FoxPro 3.0 and above
***
***  For SMTP/POP3 Email Engine (SEE) Version 3.5
***

#define SEE_MIN_RESPONSE_WAIT    1
#define SEE_MAX_RESPONSE_WAIT    2
#define SEE_CONNECT_WAIT         3
#define SEE_DISABLE_MIME         4
#define SEE_QUOTED_PRINTABLE     8
#define SEE_AUTO_CALL_DRIVER     9
#define SEE_FILE_PREFIX         10
#define SEE_SLEEP_TIME          13
#define SEE_DECODE_UNNAMED      14
#define SEE_SMTP_PORT           15
#define SEE_POP3_PORT           16
#define SEE_MAX_LINE_LENGTH     17
#define SEE_BLOCKING_MODE       18
#define SEE_ALLOW_8BITS         19
#define SEE_LOG_FILE            20
#define SEE_HIDE_SAVED_MSG      21
#define SEE_HIDE_TO_ADDR        22
#define SEE_ADDRESS_DELIMITER   23
#define SEE_WSACLEANUP          24
#define SEE_PATH_DELIMITER      25
#define SEE_ATTACH_DELIMITER    26
#define SEE_ENABLE_IMAGE        27
#define SEE_RAW_MODE            28
#define SEE_ENABLE_ESMTP        29
#define SEE_ENABLE_APOP         30
#define SEE_ATTACH_BASE_NUMBER  31
#define SEE_IGNORE_REJECTED     32

#define SEE_GET_ERROR_TEXT       1
#define SEE_GET_COUNTER          2
#define SEE_GET_RESPONSE         3
#define SEE_GET_SOCK_ERROR       4

#define SEE_GET_MESSAGE_BYTES_READ  10
#define SEE_GET_ATTACH_BYTES_READ   11
#define SEE_GET_TOTAL_BYTES_READ    12
#define SEE_GET_MESSAGE_BYTES_SENT  13
#define SEE_GET_ATTACH_BYTES_SENT   14
#define SEE_GET_TOTAL_BYTES_SENT    15
#define SEE_GET_VERSION             16
#define SEE_GET_MSG_COUNT           17
#define SEE_GET_MSG_SIZE            18
#define SEE_GET_BUFFER_COUNT        19
#define SEE_GET_CONNECT_STATUS      20
#define SEE_GET_REGISTRATION        21
#define SEE_GET_ATTACH_COUNT        22
#define SEE_GET_LAST_RESPONSE       23
#define SEE_GET_VERIFY_STATUS       24
#define SEE_GET_SERVER_IP           25
#define SEE_GET_BUILD               26
#define SEE_GET_SOCKET              27
#define SEE_GET_LOCAL_IP            28
#define SEE_GET_ATTACH_NAMES        29
#define SEE_GET_LAST_RECIPIENT      30

#define SEE_COPY_BUFFER             40
#define SEE_WRITE_BUFFER            41

#define SEE_SET_REPLY               50
#define SEE_SET_HEADER              51
#define SEE_WRITE_TO_LOG            52
#define SEE_SET_FROM                53
#define SEE_SET_CONTENT_TYPE        54
#define SEE_SET_TRANSFER_ENCODING   55
#define SEE_ADD_HEADER              56
#define SEE_SET_SECRET              57
#define SEE_SET_USER                58
#define SEE_SET_TEXT_MESSAGE        59
#define SEE_FORCE_INLINE            60
#define SEE_SET_ATTACH_CONTENT_TYPE 61

#define QUOTED_OFF   0
#define QUOTED_PLAIN 1
#define QUOTED_HTML  2
#define QUOTED_RICH  3
#define QUOTED_8859  4
#define QUOTED_USER  9

*** complete list of SEE functions follows ***

DECLARE INTEGER seeAbort in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeAttach in SEE32.DLL INTEGER NbrChans, INTEGER KeyCode
DECLARE INTEGER seeClose in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeCommand in SEE32.DLL INTEGER Chan, STRING @Text
DECLARE INTEGER seeDebug in SEE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeDecodeBuffer in SEE32.DLL STRING @CodedBuf, STRING @ClearBuf, INTEGER BufLen
DECLARE INTEGER seeDeleteEmail in SEE32.DLL INTEGER Chan, INTEGER MsgNbr
DECLARE INTEGER seeDriver in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeEncodeBuffer in SEE32.DLL STRING @ClearBuf, STRING @CodedBuf, INTEGER BufLen
DECLARE INTEGER seeErrorText in SEE32.DLL INTEGER Chan, INTEGER Code, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeExtractLine in SEE32.DLL STRING @Source, INTEGER LineNbr, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeExtractText in SEE32.DLL STRING @Source, STRING @Text, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeGetEmailCount in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeGetEmailFile in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, STRING @EmailName, STRING @EmailDir, STRING @AttachDir
DECLARE INTEGER seeGetEmailLines in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, INTEGER Lines, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeGetEmailSize in SEE32.DLL INTEGER Chan, INTEGER MsgNbr
DECLARE INTEGER seeGetEmailUID in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeIntegerParam in SEE32.DLL INTEGER Chan, INTEGER Param, INTEGER Value
DECLARE INTEGER seePop3Connect in SEE32.DLL INTEGER Chan, STRING @Server, STRING @User, STRING @Password
DECLARE INTEGER seeRelease in SEE32.DLL
DECLARE INTEGER seeSendEmail in SEE32.DLL INTEGER Chan, STRING @To, STRING @CC, STRING @BCC, STRING @Subj, STRING @Msg, STRING @Attach
DECLARE INTEGER seeSmtpConnect in SEE32.DLL INTEGER Chan, STRING @Server, STRING @From, STRING @Reply
DECLARE INTEGER seeStatistics in SEE32.DLL INTEGER Chan, INTEGER Index
DECLARE INTEGER seeStringParam in SEE32.DLL INTEGER Chan, INTEGER Param, STRING @Value
DECLARE INTEGER seeVerifyFormat in SEE32.DLL STRING @User
DECLARE INTEGER seeVerifyUser in SEE32.DLL INTEGER Chan, STRING @User


*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
SmtpServer = trim(m.Server)
SmtpFrom = "<"+trim(m.mailfrom)+">"
SmtpReply = Chr(0)
SmtpTo   = "<"+trim(m.mailto)+">"
Subject = trim(m.mailsubj)
CClist = "<"+trim(m.mailcc)+">"
BCClist = Chr(0)
* Note: Use full path name unless file is located in FoxPro directory [LocalDir = ""]
*       Be sure to terminate LocalDir with a backslash '\'.
LocalDir = ""
&& set default to "c:\see4fp"
*** END PROGRAMMER ***
Handle = FCREATE(LocalDir + "TempFile.$$$")
IF Handle < 0
  ? "ERROR: Directory " + LocalDir + " does NOT exist"
  return
else
  =FCLOSE(Handle)
endif
Message = trim(m.mailmsg)
         
         
Attachment = trim(m.zipfile)
DiagFile = LocalDir + "MAILER.LOG"

&&? "MAILER 3/27/2002"
&&?
&&? "LocalDir : " + LocalDir
&&? " Message : " + Message
&&? "  Attach : " + Attachment
&&?

Code = seeAttach(1, SEE_KEY_CODE)
if Code < 0
  ? "Cannot attach SEE (check key code)"
  return
endif
Code = seeStringParam(0, SEE_LOG_FILE, @DiagFile)
* set maximum connect wait to 50 seconds
Code = seeIntegerParam(0, SEE_CONNECT_WAIT, 50000)
* connect to SMTP server
&&? "Connecting to " + SmtpServer
Code = seeSmtpConnect(0, @SmtpServer, @SmtpFrom, @SmtpReply)
if Code < 0
  Buffer = SPACE(128)
  Code = seeErrorText(0,Code,@Buffer,128)
  ? Left(Buffer,Code)
else
  * enable MIME quoting
  Code = seeIntegerParam(0, SEE_QUOTED_PRINTABLE, QUOTED_PLAIN)
  * add an extra header
  Code = seeStringParam(0, SEE_SET_HEADER, "X-MyHeader: MAILER.PRG test program")
  * send email message
 && ? "Emailing " + Message + " with attachment " + Attachment + " to " + SmtpTo
  Code = seeSendEmail(0,@SmtpTo,@CClist,@BCClist,@Subject,@Message,@Attachment)
  if Code < 0
    Buffer = SPACE(128)
    Code = seeErrorText(0,Code,@Buffer,128)
    && ? Left(Buffer,Code)
    of=.f.
  else
    &&? "Email has been sent."    
    Code = seeClose(0)
  endif
endif
&&? "Done."
Code = seeRelease()
return



